'
' WebCdemo.bas
' Sample prog for WebCoder.dll, by Borje Hagsten, March 2003
'
' Features: 4 buttons in a ToolBar, RichEdit viewer and a StatusBar.
' Should be enough easy to understand. See also WebCoder.dll code.
'
' Open File: Open a PB/DLL/WIN code or include file.
' Save File: Save HTML formatted result as "SameName.html"
' Preview:   Preview the saved result in your default browser.
' 
' Public Domain - free to use and enhance, at own responsibility.
'
' Save this file as something like "WebCdemo.bas", compile and run.
' Note: make sure WebCoder.bas has been compiled to WebCoder.dll
' in same folder as this testprog.
'--------------------------------------------------------------------
%NOANIMATE         = 1  ' Animate control
%NOBUTTON          = 1  ' Button
%NOCOMBO           = 1  ' Combo box
%NOCOMBOEX         = 1  ' ComboBoxEx
%NODATETIMEPICK    = 1  ' Date/time picker
%NODRAGLIST        = 1  ' Drag list control
%NOEDIT            = 1  ' Edit control
%NOFLATSBAPIS      = 1  ' Flat scroll bar
%NOHEADER          = 1  ' Header control
%NOHOTKEY          = 1  ' HotKey control
%NOIMAGELIST       = 1  ' Image APIs
%NOIPADDRESS       = 1  ' IP Address edit control
%NOLIST            = 1  ' List box control
%NOLISTVIEW        = 1  ' ListView control
%NOMENUHELP        = 1  ' Menu help
%NOMONTHCAL        = 1  ' MonthCal
%NOMUI             = 1  ' MUI
%NONATIVEFONTCTL   = 1  ' Native Font control
%NOPAGESCROLLER    = 1  ' Pager
%NOPROGRESS        = 1  ' Progress control
%NOREBAR           = 1  ' Rebar control
'%NOSTATUSBAR       = 1  ' Status bar
%NOTABCONTROL      = 1  ' Tab control
'%NOTOOLBAR         = 1  ' Tool bar
'%NOTOOLTIPS        = 1  ' Tool tips
%NOTRACKBAR        = 1  ' Track bar
%NOTRACKMOUSEEVENT = 1  ' Track Mouse Event
%NOTREEVIEW        = 1  ' TreeView
%NOUPDOWN          = 1  ' Up Down arrow control
'--------------------------------------------------------------------
#COMPILE EXE
#INCLUDE "WIN32API.INC"
#INCLUDE "COMMCTRL.INC"
#INCLUDE "COMDLG32.INC"
#INCLUDE "RICHEDIT.INC"
'--------------------------------------------------------------------
%IDC_TOOLBAR    = 100
%IDC_RICHEDIT   = 102
%IDC_STATUSBAR  = 104
%IDC_OPEN       = 120
%IDC_SAVE       = 130
%IDC_VIEW       = 140
'--------------------------------------------------------------------
DECLARE CALLBACK FUNCTION DlgProc() AS LONG
DECLARE SUB CodeToHtml (BYVAL hRichEdit AS LONG, BYVAL fName AS STRING)
DECLARE SUB GotoUrl          (BYVAL hDlg AS DWORD, BYVAL url AS STRING, BYVAL Msg AS STRING)
DECLARE SUB DlgDoAllEvents
'--------------------------------------------------------------------
DECLARE FUNCTION BasToSyntaxColHtml LIB "WebCoder.dll" _
          ALIAS "BasToSyntaxColHtml" (BYVAL txt AS STRING) AS STRING
 
'
' Main entrance - create dialog and controls, etc
'--------------------------------------------------------------------
FUNCTION PBMAIN () AS LONG
  LOCAL hDlg AS DWORD, hLib AS DWORD, txt AS STRING, rc AS RECT
  LOCAL tbAddBmp AS TBADDBITMAP
  DIM Tbb(6) AS LOCAL TBBUTTON
'--------------------------------------------------------------------
 
  DIALOG NEW 0, "WebCoder 1.0",,, 390, 250, %WS_OVERLAPPEDWINDOW, 0 TO hDlg
 
'--------------------------------------------------------------------
  InitCommonControls
  hLib = LoadLibrary("RICHED32.DLL")
'--------------------------------------------------------------------
 
  IF hLib THEN
     CONTROL ADD "RichEdit", hDlg, %IDC_RICHEDIT, "", 0, 32, 390, 190, _
                 %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP OR %WS_HSCROLL OR %WS_VSCROLL OR _
                 %ES_AUTOHSCROLL OR %ES_AUTOVSCROLL OR %ES_MULTILINE OR %ES_WANTRETURN OR _
                 %ES_NOHIDESEL OR %ES_SAVESEL, %WS_EX_CLIENTEDGE
  ELSE
     CONTROL ADD TEXTBOX, hDlg, %IDC_RICHEDIT, "", 0, 32, 390, 190, _
                 %WS_CHILD OR %WS_VISIBLE OR %WS_VSCROLL OR %WS_HSCROLL OR _
                 %ES_MULTILINE OR %ES_NOHIDESEL OR %ES_WANTRETURN, _
                 %WS_EX_CLIENTEDGE
  END IF
  CONTROL SEND hDlg, %IDC_RICHEDIT, _
               %EM_SETOPTIONS, %ECOOP_OR, %ECO_SELECTIONBAR 'for left margin select..
  CONTROL SEND hDlg, %IDC_RICHEDIT, %EM_EXLIMITTEXT,  0, 1024 * 1024 - 1 '1 MB limit?
  CONTROL SEND hDlg, %IDC_RICHEDIT, %WM_SETFONT,  GetStockObject(%ANSI_FIXED_FONT), 0
 
'--------------------------------------------------------------------
 
  CONTROL ADD "ToolbarWindow32", hDlg, %IDC_TOOLBAR, "", 1, 1, 390, 20, _
                                 %WS_CHILD OR %WS_VISIBLE OR %CCS_NODIVIDER OR _
                                 %CCS_NORESIZE OR %TBSTYLE_FLAT OR %TBSTYLE_TOOLTIPS
 
  Tbb(0).fsStyle   = %TBSTYLE_BUTTON
  Tbb(0).fsState   = %TBSTATE_ENABLED
  Tbb(0).iBitmap   = 7
  Tbb(0).idCommand = %IDC_OPEN
  Tbb(0).iString   = 0
 
  Tbb(1).fsStyle = %TBSTYLE_SEP
 
  Tbb(2).fsStyle   = %TBSTYLE_BUTTON
  Tbb(2).fsState   = %TBSTATE_ENABLED '0 'disabled save button
  Tbb(2).iBitmap   = 8
  Tbb(2).idCommand = %IDC_SAVE
  Tbb(2).iString   = 1
 
  Tbb(3).fsStyle = %TBSTYLE_SEP
 
  Tbb(4).fsStyle   = %TBSTYLE_BUTTON
  Tbb(4).fsState   = %TBSTATE_ENABLED
  Tbb(4).iBitmap   = 9
  Tbb(4).idCommand = %IDC_VIEW
  Tbb(4).iString   = 2

  Tbb(5).fsStyle = %TBSTYLE_SEP

  Tbb(6).fsStyle   = %TBSTYLE_BUTTON
  Tbb(6).fsState   = %TBSTATE_ENABLED
  Tbb(6).iBitmap   = 5
  Tbb(6).idCommand = %IDCANCEL
  Tbb(6).iString   = 3
 
  'Set the image list for the toolbar
  tbAddBmp.hInst = %HINST_COMMCTRL
  tbAddBmp.nID   = %IDB_STD_LARGE_COLOR
  CONTROL SEND hDlg, %IDC_TOOLBAR, %TB_ADDBITMAP, UBOUND(tbb) + 1, VARPTR(tbAddBmp)
 
  ' Set the buttons
  CONTROL SEND hDlg, %IDC_TOOLBAR, %TB_BUTTONSTRUCTSIZE,  SIZEOF(tbb(0)), 0
  CONTROL SEND hDlg, %IDC_TOOLBAR, %TB_ADDBUTTONS, UBOUND(tbb) + 1, VARPTR(tbb(0))
'--------------------------------------------------------------------
 
  CONTROL ADD "msctls_statusbar32", hDlg, %IDC_STATUSBAR, "", 0, 0, 390, 12, _ 
                                   %WS_CHILD OR %WS_VISIBLE OR %SBARS_SIZEGRIP
  REDIM prts(3) AS LONG
  GetClientRect hDlg, rc
  prts(0) = rc.nRight / 4     : prts(1) = rc.nRight / 4 * 2
  prts(2) = rc.nRight / 4 * 3 : prts(3) = -1
  CONTROL SEND hDlg, %IDC_STATUSBAR, %SB_SETPARTS, 4, VARPTR(prts(0))
  CONTROL SEND hDlg, %IDC_STATUSBAR, %SB_SETTEXT, 0 OR %SBT_NOBORDERS, STRPTR(txt)
  CONTROL SEND hDlg, %IDC_STATUSBAR, %SB_SETTEXT, 1 OR %SBT_NOBORDERS, STRPTR(txt)
  CONTROL SEND hDlg, %IDC_STATUSBAR, %SB_SETTEXT, 2, STRPTR(txt)
  CONTROL SEND hDlg, %IDC_STATUSBAR, %SB_SETTEXT, 3, STRPTR(txt)
'--------------------------------------------------------------------
 
  DIALOG SHOW MODAL hDlg CALL DlgProc
 
  IF hLib THEN FreeLibrary hLib 'unload RichEdit on exit..
 
END FUNCTION
 
'
' Main dialog's callback procedure
'--------------------------------------------------------------------
CALLBACK FUNCTION DlgProc() AS LONG
  LOCAL dwStyle AS DWORD, ff AS LONG, lRes AS LONG, fName AS STRING, sBuf AS STRING
  LOCAL rc AS RECT, rc2 AS RECT, lpToolTip AS TOOLTIPTEXT PTR
 
  SELECT CASE CBMSG
     CASE %WM_INITDIALOG ' first message - initiate
        STATIC hRichEdit AS DWORD, hStatus AS DWORD, hToolBar AS DWORD, _
               Path AS STRING, SaveFName AS STRING
 
        hRichEdit = GetDlgItem(CBHNDL, %IDC_RICHEDIT)
        hStatus   = GetDlgItem(CBHNDL, %IDC_STATUSBAR)
        hToolBar  = GetDlgItem(CBHNDL, %IDC_TOOLBAR)
        Path      = CURDIR$
 
     CASE %WM_COMMAND ' act on controls
        SELECT CASE CBCTL
           CASE %IDC_OPEN ' Show Open dialog
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 fName   = "*.BAS;*.INC"
                 sBuf    = "PB code files (*.BAS, *.INC)|*.bas;*.inc|" + _
                           "All Files (*.*)|*.*"
                 dwStyle = %OFN_EXPLORER OR %OFN_FILEMUSTEXIST OR %OFN_HIDEREADONLY
                 IF OpenFileDialog(CBHNDL, "", fName, Path, sBuf, "BAS", dwStyle) THEN
                    DlgDoAllEvents  ' take a breath for proper redraw between actions
                    CodeToHtml hRichEdit, fName ' open file and do conversion
    
                    Path = LEFT$(fName, INSTR(-1, fName, ANY "\/"))
                    sBuf = "WebCoder 1.0 - " + fName
                    SetWindowText CBHNDL, BYVAL STRPTR(sBuf)

                    lRes = INSTR(-1, fName, ANY "\/")
                    IF lRes THEN
                       fName = MID$(fName, lRes + 1)
                       lRes = INSTR(-1, fName, ".")
                       IF lRes THEN SaveFName = LEFT$(fName, lRes) + "html"
                    END IF
                 END IF
              END IF

 
           CASE %IDC_SAVE 'Show Save dialog
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 IF SaveFName = "" THEN SaveFName = "*.HTML"
                 sBuf    = "HTML files (*.HTML)|*.html"
                 dwStyle = %OFN_EXPLORER OR %OFN_HIDEREADONLY OR %OFN_OVERWRITEPROMPT
                 IF SaveFileDialog(CBHNDL, "", SaveFName, Path, sBuf, "HTML", dwStyle) THEN
                    DlgDoAllEvents  ' take a breath for proper redraw between actions
 
                    lRes = SendMessage(hRichEdit, %WM_GETTEXTLENGTH, 0, 0)
                    IF lRes THEN
                       INCR lRes 'make room for terminating zero
                       sBuf = SPACE$(lRes) 'allocate string memory
                       SendMessage hRichEdit, %WM_GETTEXT, lRes, STRPTR(sBuf) 'grab text
                       sBuf = RTRIM$(sBuf, CHR$(0)) 'trim off ending nul
                    ELSE
                       EXIT FUNCTION
                    END IF
 
                    OPEN SaveFName FOR BINARY AS ff LEN = 8192
                       IF ERR THEN
                          MessageBeep &HFFFFFFFF
                          EXIT FUNCTION
                       END IF
                       PUT$ ff, sBuf
                       SETEOF ff
                    CLOSE ff
    
                    Path = LEFT$(SaveFName, INSTR(-1, SaveFName, ANY "\/"))
                    lRes = INSTR(-1, SaveFName, ANY "\/")
                    IF lRes THEN SaveFName = MID$(SaveFName, lRes + 1)
                    sBuf = "WebCoder 1.0 - " + Path + SaveFName
                    SetWindowText CBHNDL, BYVAL STRPTR(sBuf)
                    SendMessage hRichEdit, %EM_SETMODIFY, 0, 0
                 END IF
              END IF


           CASE %IDC_VIEW
              IF SendMessage(hRichEdit, %WM_GETTEXTLENGTH, 0, 0) = 0 THEN
                 MSGBOX "Nothing to preview.", _
                        %MB_OK OR %MB_ICONWARNING OR %MB_TASKMODAL, _
                        "Preview HTML"
                 EXIT FUNCTION
              END IF

              IF SendMessage(hRichEdit, %EM_GETMODIFY, 0, 0) OR DIR$(SaveFName) = "" THEN
                 SendMessage CBHNDL, %WM_COMMAND, MAKLNG(%IDC_SAVE, %BN_CLICKED), 0
              END IF

              IF LEN(SaveFName) AND DIR$(SaveFName) > "" AND _
                 SendMessage(hRichEdit, %EM_GETMODIFY, 0, 0) = 0 THEN

                 CALL GotoUrl(CBHNDL, SaveFName, _
                      "Do you want to preview the result in your default browser?")
              ELSE
                 MSGBOX "Please make sure the HTML result has been saved.", _
                        %MB_OK OR %MB_ICONWARNING OR %MB_TASKMODAL, _
                        "Preview HTML"
              END IF


           CASE %IDCANCEL 'Close
              IF CBCTLMSG = %BN_CLICKED OR CBCTLMSG = 1 THEN
                 DIALOG END CBHNDL
              END IF
        END SELECT
 
     CASE %WM_NOTIFY 'for tooltip
        lpToolTip = CBLPARAM
        IF @lpToolTip.hdr.code = %TTN_NEEDTEXT THEN
           SELECT CASE @lpToolTip.hdr.idFrom
              CASE %IDC_OPEN       : sBuf = " Open a code file for conversion to HTLM "
              CASE %IDC_SAVE       : sBuf = " Save converted text as HTML "
              CASE %IDC_VIEW       : sBuf = " Preview saved result in default browser "
              CASE %IDCANCEL       : sBuf = " Close the program "
           END SELECT
           @lpToolTip.lpszText = STRPTR(sBuf)
        END IF
 
     CASE %WM_SIZE 'act on dialog resize
        CONTROL SEND CBHNDL, %IDC_TOOLBAR, %WM_SIZE, 0, 0
        CONTROL SEND CBHNDL, %IDC_STATUSBAR, %WM_SIZE, 0, 0
        IF CBWPARAM <> %SIZE_MINIMIZED THEN
           GetWindowRect hToolBar, rc            ' get ToolBar's coordinates
           MapWindowPoints 0, CBHNDL, rc, 2      ' map rect to dialog - we need bottom pos
           GetWindowRect hStatus, rc2            ' get StatusBar's coordinates
           rc2.nBottom = rc2.nBottom - rc2.nTop  ' we need StatusBar's height
 
           SetWindowPos hRichEdit, 0, 0, rc.nBottom, _
                        LOWRD(CBLPARAM), _
                        HIWRD(CBLPARAM) - rc.nBottom - rc2.nBottom, _
                        %SWP_NOZORDER
        END IF
 
  END SELECT
END FUNCTION
 
'
' Open given code file, convert text to HTML and insert into RichEdit
'--------------------------------------------------------------------
SUB CodeToHtml (BYVAL hRichEdit AS LONG, BYVAL fName AS STRING)
  LOCAL ff AS LONG, t AS SINGLE, sBuf AS STRING, txt AS STRING
 
  ff = FREEFILE
  OPEN fName FOR BINARY AS ff LEN = 8192
     IF ERR THEN                'if file couldn't be opened
        MessageBeep &HFFFFFFFF  'trigger a speaker beep on errors..
        RESET : ERRCLEAR        'Should of course flash a message here, but I'm lazy..
        EXIT SUB
     END IF
     GET$ ff, LOF(ff), sBuf     'all is ok, read entire contents into text buffer
  CLOSE ff                      'close file
 
  IF LEN(sBuf) = 0 THEN         'if length is zero, exit
     MessageBeep &HFFFFFFFF
     EXIT SUB
  END IF
'--------------------------------------------------------------------
 
  txt = " Code size:  " + USING$("#,###", LEN(sBuf))
  CONTROL SEND GetParent(hRichEdit), %IDC_STATUSBAR, %SB_SETTEXT, 2, STRPTR(txt)
  txt = " Please wait.."
  CONTROL SEND GetParent(hRichEdit), %IDC_STATUSBAR, %SB_SETTEXT, 0 OR %SBT_NOBORDERS, STRPTR(txt)
 
  MOUSEPTR 11  ' show Hourglass mouse pointer during process
  t = TIMER    ' for timing Syntax color parser
 
  IF UCASE$(RIGHT$(fName, 3)) = ".RC" THEN
     'CALL SyntaxColorRC  'convert resource file code to RTF - this is fast
  ELSE
     sBuf = BasToSyntaxColHtml (sBuf)  ' convert PB code to RTF (in WebCoder.dll)
  END IF
 
  t   = TIMER - t
  txt = " Parsing took  " + FORMAT$(t, "0.000") + " sec."
  CONTROL SEND GetParent(hRichEdit), %IDC_STATUSBAR, _
               %SB_SETTEXT, 0 OR %SBT_NOBORDERS, STRPTR(txt)
 
  txt = "Please wait.."
  CONTROL SEND GetParent(hRichEdit), %IDC_STATUSBAR, _
               %SB_SETTEXT, 1 OR %SBT_NOBORDERS, STRPTR(txt)
 
  t = TIMER  ' for timing RichEdit SetText
  SendMessage hRichEdit, %WM_SETTEXT, 0, STRPTR(sBuf) ' show converted text
  t = TIMER - t
 
  txt = "RichEdit took  " + FORMAT$(t, "0.000") + " sec."
  CONTROL SEND GetParent(hRichEdit), %IDC_STATUSBAR, _
               %SB_SETTEXT, 1 OR %SBT_NOBORDERS, STRPTR(txt)
 
  txt = " HTML size:  " + USING$("#,###", LEN(sBuf))
  CONTROL SEND GetParent(hRichEdit), %IDC_STATUSBAR, %SB_SETTEXT, 3, STRPTR(txt)
 
  MOUSEPTR 1  ' done, so reset mouse pointer
 
END SUB

'
' Custom DOEVENTS to make sure all pending messages are processed.
'--------------------------------------------------------------------
SUB DlgDoAllEvents
  LOCAL Msg AS tagMsg
  DO WHILE PeekMessage(Msg, 0, 0, 0, %PM_NOREMOVE) 'peek only, do not remove
     DIALOG DOEVENTS                               'let DDT handle all pending messages
  LOOP
END SUB

'
' Generic routine for viewing a file or sending a user to a specific web-address
'
SUB GotoUrl (BYVAL hDlg AS DWORD, BYVAL url AS STRING, BYVAL Msg AS STRING)
  LOCAL Title AS STRING
  Title = "Preview HTML result?"
 
  IF MessageBox(hDlg, BYVAL STRPTR(Msg), BYVAL STRPTR(Title), _
                     %MB_YESNO OR %MB_ICONQUESTION) = %IDYES THEN
 
     IF ShellExecute(0, "", BYVAL STRPTR(url), "", "", %SW_SHOWNORMAL) <= 32 THEN 'on error, show msg
        Title = "No web-browser found!"
        Msg = "Could not start your web-browser." & $CRLF
        Msg = Msg & "Please make sure a browser is properly installed and try again."
        CALL MessageBox(hDlg, BYVAL STRPTR(Msg), BYVAL STRPTR(Title), %MB_ICONEXCLAMATION)
     END IF
 
  END IF
END SUB
